'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var cn = require('classnames');
var coreComponentsIconButton = require('@alfalab/core-components-icon-button');
var coreComponentsLink = require('@alfalab/core-components-link');
var coreComponentsSpinner = require('@alfalab/core-components-spinner');
var CrossMIcon = require('@alfalab/icons-glyph/CrossMIcon');
var CheckmarkCircleMIcon = require('@alfalab/icons-glyph/CheckmarkCircleMIcon');
var AlertCircleMIcon = require('@alfalab/icons-glyph/AlertCircleMIcon');
var PointerDownMIcon = require('@alfalab/icons-glyph/PointerDownMIcon');
var iconsGlyph = require('@alfalab/icons-glyph');
var utils = require('./utils.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var cn__default = /*#__PURE__*/_interopDefaultLegacy(cn);

var styles = {"component":"file-upload-item__component_7r1jc","infoSection":"file-upload-item__infoSection_7r1jc","info":"file-upload-item__info_7r1jc","icon":"file-upload-item__icon_7r1jc","errorIcon":"file-upload-item__errorIcon_7r1jc","successIcon":"file-upload-item__successIcon_7r1jc","name":"file-upload-item__name_7r1jc","meta":"file-upload-item__meta_7r1jc","size":"file-upload-item__size_7r1jc","delete":"file-upload-item__delete_7r1jc","download":"file-upload-item__download_7r1jc","errorWrapper":"file-upload-item__errorWrapper_7r1jc","restore":"file-upload-item__restore_7r1jc","spinnerWrapper":"file-upload-item__spinnerWrapper_7r1jc","spinner":"file-upload-item__spinner_7r1jc","uploadPercent":"file-upload-item__uploadPercent_7r1jc"};
require('./index.css')

var FileUploadItem = function (_a) {
    var className = _a.className, children = _a.children, _b = _a.id, id = _b === void 0 ? '0' : _b, _c = _a.name, name = _c === void 0 ? '' : _c, size = _a.size, _d = _a.icon, Icon = _d === void 0 ? utils.fileIcon(name) : _d, uploadDate = _a.uploadDate, downloadLink = _a.downloadLink, download = _a.download, uploadStatus = _a.uploadStatus, _e = _a.uploadPercent, uploadPercent = _e === void 0 ? 0 : _e, _f = _a.error, error = _f === void 0 ? uploadStatus === 'ERROR' ? 'Не удалось загрузить файл' : undefined : _f, showDelete = _a.showDelete, showRestore = _a.showRestore, onDelete = _a.onDelete, onDownload = _a.onDownload, onRestore = _a.onRestore, dataTestId = _a.dataTestId;
    var handleDownload = React.useCallback(function (event) {
        if (onDownload) {
            event.preventDefault();
            onDownload(id);
        }
    }, [id, onDownload]);
    var handleDelete = React.useCallback(function () {
        if (onDelete)
            onDelete(id);
    }, [id, onDelete]);
    var handleRestore = React.useCallback(function () {
        if (onRestore)
            onRestore(id);
    }, [id, onRestore]);
    var renderIcon = React.useCallback(function () {
        if (showRestore) {
            return React__default['default'].createElement(iconsGlyph.ClockMIcon, { className: styles.restoreIcon });
        }
        switch (uploadStatus) {
            case 'ERROR':
                return React__default['default'].createElement(AlertCircleMIcon.AlertCircleMIcon, { className: styles.errorIcon });
            case 'SUCCESS':
                return React__default['default'].createElement(CheckmarkCircleMIcon.CheckmarkCircleMIcon, { className: styles.successIcon });
            case 'LOADING':
            case 'UPLOADING':
                return (React__default['default'].createElement("div", { className: styles.spinnerWrapper },
                    React__default['default'].createElement(coreComponentsSpinner.Spinner, { visible: true, className: styles.spinner })));
            default: {
                return React__default['default'].createElement(Icon, { className: styles.icon });
            }
        }
    }, [showRestore, uploadStatus]);
    var renderInfoSection = React.useCallback(function () { return (React__default['default'].createElement("div", { className: styles.infoSection },
        React__default['default'].createElement("div", { className: styles.name }, name),
        uploadStatus === 'ERROR' && error && (React__default['default'].createElement("div", { className: styles.errorWrapper, role: 'alert' }, error)))); }, [name, uploadStatus, error]);
    var showMeta = !showRestore && (!uploadStatus || uploadStatus === 'SUCCESS');
    var showDownload = Boolean(downloadLink) && !showRestore;
    return (React__default['default'].createElement("div", { className: cn__default['default'](className, styles.component, uploadStatus && styles[uploadStatus.toLocaleLowerCase()]), "data-test-id": dataTestId },
        React__default['default'].createElement("div", { className: styles.info },
            renderIcon(),
            renderInfoSection(),
            children,
            uploadStatus === 'UPLOADING' && (React__default['default'].createElement("span", { className: styles.uploadPercent }, Math.round(uploadPercent) + "%")),
            showMeta && (React__default['default'].createElement("div", { className: styles.meta },
                uploadDate && React__default['default'].createElement("span", { key: uploadDate }, uploadDate),
                size && (React__default['default'].createElement("span", { key: size, className: styles.size }, utils.humanFileSize(size)))))),
        showRestore && (React__default['default'].createElement(coreComponentsLink.Link, { pseudo: true, className: styles.restore, onClick: handleRestore }, "\u0412\u043E\u0441\u0441\u0442\u0430\u043D\u043E\u0432\u0438\u0442\u044C")),
        showDownload && (React__default['default'].createElement(coreComponentsIconButton.IconButton, { size: 'xxs', icon: PointerDownMIcon.PointerDownMIcon, className: styles.download, "aria-label": '\u0441\u043A\u0430\u0447\u0430\u0442\u044C', href: downloadLink, onClick: handleDownload, download: download })),
        showDelete && !showRestore && (React__default['default'].createElement(coreComponentsIconButton.IconButton, { size: 'xxs', icon: CrossMIcon.CrossMIcon, onClick: handleDelete, className: styles.delete, "aria-label": '\u0443\u0434\u0430\u043B\u0438\u0442\u044C' }))));
};

exports.FileUploadItem = FileUploadItem;
